Index: orxonox/branches/physics/src/lib/graphics/importer/objModel.cc
===================================================================
--- orxonox/branches/physics/src/lib/graphics/importer/objModel.cc	(revision 3866)
+++ orxonox/branches/physics/src/lib/graphics/importer/objModel.cc	(revision 3953)
@@ -18,7 +18,12 @@
 #include "objModel.h"
 
-#include <fstream>
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+
+#define PARSELINELENGTH 8192
 
 #include "debug.h"
+#include "compiler.h"
 
 /**
@@ -27,5 +32,5 @@
    \param scaling The factor that the model will be scaled with.
 */
-OBJModel::OBJModel(char* fileName, float scaling)
+OBJModel::OBJModel(const char* fileName, float scaling) : Model(fileName)
 {
   this->initializeOBJ();
@@ -34,7 +39,5 @@
   this->importFile (fileName);
 
-  this->importToGL ();
-
-  this->cleanup();
+  this->finalize();
 }
 
@@ -63,6 +66,4 @@
   this->objFileName = NULL;
   this->mtlFileName = NULL;
-
-  this->initialize();
 }
 
@@ -71,5 +72,5 @@
    \param fileName The file to import
 */
-bool OBJModel::importFile (char* fileName)
+bool OBJModel::importFile (const char* fileName)
 {
   PRINTF(4)("preparing to read in file: %s\n", fileName);
@@ -83,5 +84,6 @@
   char pathSplitter='/';
 #endif /* __WIN32__ */
-  char* tmpName = fileName;
+  char* tmpName;
+  strcpy(tmpName, fileName);
   if (tmpName[0] == pathSplitter)
     tmpName++;
@@ -100,6 +102,5 @@
   
   this->setName(name);
-  if (this->material)
-    this->material->addTexturePath(this->objPath);
+
   this->objFileName = new char[strlen(name)+1];
   strcpy (this->objFileName, name);
@@ -120,67 +121,62 @@
   strcat(fileName, this->objFileName);
 
-  ifstream* OBJ_FILE = new ifstream(fileName);
-  if (OBJ_FILE->fail())
-    {
-      PRINTF(1)("unable to open .OBJ file: %s\n Loading cube-Model instead.\n", fileName);
-      cubeModel();
-      OBJ_FILE->close();
-      delete []fileName;
-      delete OBJ_FILE;
+  FILE* stream;
+  if( (stream = fopen (fileName, "r")) == NULL)
+    {
+      printf("IniParser could not open %s\n", fileName);
       return false;
     }
-  PRINTF(4)("Reading from opened file %s\n", fileName);
-  char Buffer[10000];
-  while(!OBJ_FILE->eof())
-    {
-      OBJ_FILE->getline(Buffer, 10000);
-      PRINTF(5)("Read input line: %s\n", Buffer);
+
+  char buffer[PARSELINELENGTH];
+  while(fgets(buffer, PARSELINELENGTH, stream))
+    {
+      // line termiated with \0 not \n
+      if (buffer[strlen(buffer)-1] == '\n')
+	buffer[strlen(buffer)-1] = '\0';
+
+      // case vertice
+      if (!strncmp(buffer, "v ", 2))
+	{
+	  this->addVertex(buffer+2);
+	}
+
+      // case face
+      else if (!strncmp(buffer, "f ", 2))
+	{
+	  this->addFace (buffer+2);
+	}
       
-
-      // case vertice
-      if (!strncmp(Buffer, "v ", 2))
-	{
-	  this->addVertex(Buffer+2);
-	}
-
-      // case face
-      else if (!strncmp(Buffer, "f ", 2))
-	{
-	  this->addFace (Buffer+2);
-	}
-      
-      else if (!strncmp(Buffer, "mtllib ", 7))
-	{
-	  this->readMtlLib (Buffer+7);
-	}
-
-      else if (!strncmp(Buffer, "usemtl ", 7))
-	{
-	  this->addUseMtl (Buffer+7);
+      else if (!strncmp(buffer, "mtllib ", 7))
+	{
+	  this->readMtlLib (buffer+7);
+	}
+
+      else if (!strncmp(buffer, "usemtl ", 7))
+	{
+	  this->setMaterial (buffer+7);
 	}
 
       // case VertexNormal
-      else if (!strncmp(Buffer, "vn ", 3))
-	{
-	  this->addVertexNormal(Buffer+3);
+      else if (!strncmp(buffer, "vn ", 3))
+	{
+	  this->addVertexNormal(buffer+3);
 	}
       
       // case VertexTextureCoordinate
-      else if (!strncmp(Buffer, "vt ", 3))
-	{
-	  this->addVertexTexture(Buffer+3);
+      else if (!strncmp(buffer, "vt ", 3))
+	{
+	  this->addVertexTexture(buffer+3);
 	}
       // case group
-      else if (!strncmp(Buffer, "g ", 2))
-	{
-	  this->addGroup (Buffer+2);
-	}
-      else if (!strncmp(Buffer, "s ", 2)) //! \todo smoothing groups have to be implemented
-	{
-	  PRINTF(2)("smoothing groups not supportet yet. line: %s\n", Buffer);
-	}
-    }
-  OBJ_FILE->close();
-  delete OBJ_FILE;
+      else if (!strncmp(buffer, "g ", 2))
+	{
+	  this->addGroup (buffer+2);
+	}
+      else if (!strncmp(buffer, "s ", 2)) //! \todo smoothing groups have to be implemented
+	{
+	  PRINTF(2)("smoothing groups not supportet yet. line: %s\n", buffer);
+	}
+    }
+  fclose (stream);
   delete []fileName;
   return true;
@@ -196,5 +192,5 @@
 
 */
-bool OBJModel::readMtlLib (char* mtlFile)
+bool OBJModel::readMtlLib (const char* mtlFile)
 {
   this->mtlFileName = new char [strlen(mtlFile)+1];
@@ -205,87 +201,95 @@
   
 
-  PRINTF(4)("Opening mtlFile: %s\n", fileName);
-
-  ifstream* MTL_FILE = new ifstream (fileName);
-  if (MTL_FILE->fail())
-    {
-      PRINTF(2)("unable to open file: %s\n", fileName);
-      MTL_FILE->close();
-      delete []fileName;
-      delete MTL_FILE;
+  FILE* stream;
+  if( (stream = fopen (fileName, "r")) == NULL)
+    {
+      printf("IniParser could not open %s\n", fileName);
       return false;
     }
-  char Buffer[500];
-  Material* tmpMat = material;
-  while(!MTL_FILE->eof())
-    {
-      MTL_FILE->getline(Buffer, 500);
-      PRINTF(5)("found line in mtlFile: %s\n", Buffer);
+
+  char buffer[PARSELINELENGTH];
+  Material* tmpMat = NULL;
+
+  while(fgets(buffer, PARSELINELENGTH, stream))
+    {
+      PRINTF(5)("found line in mtlFile: %s\n", buffer);
+
+      // line termiated with \0 not \n
+      if (buffer[strlen(buffer)-1] == '\n')
+	buffer[strlen(buffer)-1] = '\0';
+
+      // create new Material
+      if (!strncmp(buffer, "newmtl ", 7))
+	{
+	  tmpMat = this->addMaterial(buffer+7);//tmpMat->addMaterial(buffer+7);
+	}
+      // setting a illumMode
+      else if (!strncmp(buffer, "illum ", 6))
+	{
+	  if (likely(tmpMat != NULL))
+	    tmpMat->setIllum(buffer+6);
+
+	}
+      // setting Diffuse Color
+      else if (!strncmp(buffer, "Kd ", 3))
+	{
+	  if (likely(tmpMat != NULL))
+	    tmpMat->setDiffuse(buffer+3);
+	}
+      // setting Ambient Color
+      else if (!strncmp(buffer, "Ka ", 3))
+	{
+	  if (likely(tmpMat != NULL))
+	    tmpMat->setAmbient(buffer+3);
+	}
+      // setting Specular Color
+      else if (!strncmp(buffer, "Ks ", 3))
+	{
+	  if (likely(tmpMat != NULL))
+	    tmpMat->setSpecular(buffer+3);
+	}
+      // setting The Specular Shininess
+      else if (!strncmp(buffer, "Ns ", 3))
+	{
+	  if (likely(tmpMat != NULL))
+	    tmpMat->setShininess(buffer+3);
+	}
+      // setting up transparency
+      else if (!strncmp(buffer, "d ", 2))
+	{
+	  if (likely(tmpMat != NULL))
+	    tmpMat->setTransparency(buffer+2);
+	}
+      else if (!strncmp(buffer, "Tf ", 3))
+	{
+	  if (likely(tmpMat != NULL))
+	    tmpMat->setTransparency(buffer+3);
+	}
       
-
-      // create new Material
-      if (!strncmp(Buffer, "newmtl ", 7))
-	{
-	  tmpMat = tmpMat->addMaterial(Buffer+7);
-	  //	  PRINTF(2)("%s, %p\n", tmpMat->getName(), tmpMat);
-	}
-      // setting a illumMode
-      else if (!strncmp(Buffer, "illum ", 6))
-	{
-	  tmpMat->setIllum(Buffer+6);
-
-	}
-      // setting Diffuse Color
-      else if (!strncmp(Buffer, "Kd ", 3))
-	{
-	  tmpMat->setDiffuse(Buffer+3);
-	}
-      // setting Ambient Color
-      else if (!strncmp(Buffer, "Ka ", 3))
-	{
-	  tmpMat->setAmbient(Buffer+3);
-	}
-      // setting Specular Color
-      else if (!strncmp(Buffer, "Ks ", 3))
-	{
-	  tmpMat->setSpecular(Buffer+3);
-	}
-      // setting The Specular Shininess
-      else if (!strncmp(Buffer, "Ns ", 3))
-	{
-	  tmpMat->setShininess(Buffer+3);
-	}
-      // setting up transparency
-      else if (!strncmp(Buffer, "d ", 2))
-	{
-	  tmpMat->setTransparency(Buffer+2);
-	}
-      else if (!strncmp(Buffer, "Tf ", 3))
-	{
-	  tmpMat->setTransparency(Buffer+3);
-	}
-      
-      else if (!strncmp(Buffer, "map_Kd ", 7))
-	{
-	  tmpMat->setDiffuseMap(Buffer+7);
-	}
-      else if (!strncmp(Buffer, "map_Ka ", 7))
-	{
-	  tmpMat->setAmbientMap(Buffer+7);
-	}
-      else if (!strncmp(Buffer, "map_Ks ", 7))
-	{
-	  tmpMat->setSpecularMap(Buffer+7);
-	}
-      else if (!strncmp(Buffer, "bump ", 5))
-	{
-	  tmpMat->setBump(Buffer+7);
+      else if (!strncmp(buffer, "map_Kd ", 7))
+	{
+	  if (likely(tmpMat != NULL))
+	    tmpMat->setDiffuseMap(buffer+7);
+	}
+      else if (!strncmp(buffer, "map_Ka ", 7))
+	{
+	  if (likely(tmpMat != NULL))
+	    tmpMat->setAmbientMap(buffer+7);
+	}
+      else if (!strncmp(buffer, "map_Ks ", 7))
+	{
+	  if (likely(tmpMat != NULL))
+	    tmpMat->setSpecularMap(buffer+7);
+	}
+      else if (!strncmp(buffer, "bump ", 5))
+	{
+	  if (likely(tmpMat != NULL))
+	    tmpMat->setBump(buffer+7);
 	}
      
 
     }
-  MTL_FILE->close();
+  fclose(stream);
   delete []fileName;
-  delete MTL_FILE;
   return true;
 }
Index: orxonox/branches/physics/src/lib/graphics/importer/objModel.h
===================================================================
--- orxonox/branches/physics/src/lib/graphics/importer/objModel.h	(revision 3866)
+++ orxonox/branches/physics/src/lib/graphics/importer/objModel.h	(revision 3953)
@@ -13,5 +13,5 @@
 {
  public:
-  OBJModel(char* fileName, float scaling = 1.0);
+  OBJModel(const char* fileName, float scaling = 1.0);
   virtual ~OBJModel();
   void initializeOBJ(void);
@@ -24,7 +24,7 @@
 
   ///// readin /////
-  bool importFile (char* fileName);
+  bool importFile (const char* fileName);
   bool readFromObjFile (void);
-  bool readMtlLib (char* matFile);
+  bool readMtlLib (const char* matFile);
 };
 
Index: orxonox/branches/physics/src/lib/graphics/importer/primitive_model.cc
===================================================================
--- orxonox/branches/physics/src/lib/graphics/importer/primitive_model.cc	(revision 3866)
+++ orxonox/branches/physics/src/lib/graphics/importer/primitive_model.cc	(revision 3953)
@@ -33,6 +33,4 @@
 PrimitiveModel::PrimitiveModel(PRIMITIVE type, float size, unsigned int detail)
 {
-  this->initialize();
-
   switch (type)
     {
@@ -54,7 +52,5 @@
       break;
     }
-  this->importToGL ();
-
-  this->cleanup();
+  this->finalize();
 }
 
@@ -123,13 +119,13 @@
 	    {
 	      v1 = vertexCount+1;
-	      this->addFace(3, TEXCOORD, v1, v1, v3, v3, v4, v4);
+	      this->addFace(3, VERTEX_TEXCOORD, v1, v1, v3, v3, v4, v4);
 	    }
 	  else if (j == detail)
 	    {
 	      v3 = vertexCount+2;
-	      this->addFace(3, TEXCOORD, v1, v1, v2, v2, v3, v3);
+	      this->addFace(3, VERTEX_TEXCOORD, v1, v1, v2, v2, v3, v3);
 	    }
 	  else
-	    this->addFace(4, TEXCOORD, v1, v1, v2, v2, v3, v3, v4, v4);
+	    this->addFace(4, VERTEX_TEXCOORD, v1, v1, v2, v2, v3, v3, v4, v4);
 	}
     }
@@ -163,15 +159,15 @@
       p1 = 2*i+1;
       p2 = 2*i+2;
-      if (i <= detail);
       p3 = 2*i+4;
       p4 = 2*i+3;
       // something is wrong here
-      this->addFace(4, 0, p1, p2, p3, p4);
-      this->addFace(3, 0, p4, p1, 2*detail+1);
-      this->addFace(3, 0, p2, p3, 2*detail+2);
-    }
-  addFace(4,0, 2*detail-1, 2*detail, 2, 1);
-  this->addFace(3, VERTEX, 1, 2*detail-1, 2*detail+1);
-  this->addFace(3, VERTEX, 2*detail, 2, 2*detail+2);
+      this->addFace(4, VERTEX_ONLY, p1, p2, p3, p4);
+      this->addFace(3, VERTEX_ONLY, p4, p1, 2*detail+1);
+      this->addFace(3, VERTEX_ONLY, p2, p3, 2*detail+2);
+    }
+  // caps
+  this->addFace(4, VERTEX_ONLY, 2*detail-1, 2*detail, 2, 1);
+  this->addFace(3, VERTEX_ONLY, 1, 2*detail-1, 2*detail+1);
+  this->addFace(3, VERTEX_ONLY, 2*detail, 2, 2*detail+2);
 }
 
@@ -207,6 +203,6 @@
       else
 	v2 = i+4;
-      this->addFace(3, VERTEX, 1, v1, v2);
-      this->addFace(3, VERTEX, 2, v1, v2); 
+      this->addFace(3, VERTEX_ONLY, 1, v1, v2);
+      this->addFace(3, VERTEX_ONLY, 2, v1, v2); 
     }
 }
@@ -238,5 +234,5 @@
 	v3 = (i+1)*detail + (j+1);
 	v4 = i*detail + (j+1);
-	this->addFace(4, TEXCOORD, v1, v1, v2, v2, v3, v3, v4, v4);
+	this->addFace(4, VERTEX_TEXCOORD, v1, v1, v2, v2, v3, v3, v4, v4);
       }
 }
Index: orxonox/branches/physics/src/lib/graphics/importer/texture.cc
===================================================================
--- orxonox/branches/physics/src/lib/graphics/importer/texture.cc	(revision 3866)
+++ orxonox/branches/physics/src/lib/graphics/importer/texture.cc	(revision 3953)
@@ -23,22 +23,9 @@
    \brief Constructor for a Texture
 */
-Texture::Texture(void)
-{
-  this->pImage = new Image;
-  this->pImage->data = NULL;
-  this->map = NULL;
-  this->texture = 0;
-}
-
-/**
-   \brief Constructor for a Texture
-*/
 Texture::Texture(const char* imageName)
 {
-  this->pImage = new Image;
-  this->pImage->data = NULL;
-  this->map = NULL;
   this->texture = 0;
-  this->loadImage(imageName);
+  if (imageName)
+    this->loadImage(imageName);
 }  
 
@@ -50,7 +37,4 @@
 Texture::~Texture(void)
 {
-  if (this->pImage->data)
-    delete []this->pImage->data;
-  delete pImage;
   if (this->texture)
     glDeleteTextures(1, &this->texture);
@@ -73,22 +57,86 @@
 /**
    \brief Loads a Texture to the openGL-environment.
-   \param pImage The Image to load to openGL
+   \param surface the Image to load to openGL
+   \returns The ID of the texture.
 */
-bool Texture::loadTexToGL (Image* pImage)
+GLuint Texture::loadTexToGL (SDL_Surface* surface)
 {
   if (GraphicsEngine::texturesEnabled)
     {
       PRINTF(4)("Loading texture to OpenGL-Environment.\n");
-      glGenTextures(1, &this->texture);
-      glBindTexture(GL_TEXTURE_2D, this->texture);
-      /* not Working, and not needed. 
-	 glTexImage2D( GL_TEXTURE_2D, 0, 3, width,
-	 height, 0, GL_BGR,
-	 GL_UNSIGNED_BYTE, map->pixels );
-      */ 
-      gluBuild2DMipmaps(GL_TEXTURE_2D, 3, pImage->width, pImage->height, pImage->format, GL_UNSIGNED_BYTE, pImage->data);
+
+      GLuint texture;
+      int w, h;
+      SDL_Surface *image;
+      SDL_Rect area;
+      Uint32 saved_flags;
+      Uint8  saved_alpha;
       
-      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
-      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);	
+      w = surface->w;
+      h = surface->h;
+      
+      image = SDL_CreateRGBSurface(SDL_SWSURFACE,
+				   w, h,
+				   32,
+#if SDL_BYTEORDER == SDL_LIL_ENDIAN /* OpenGL RGBA masks */
+				   0x000000FF, 
+				   0x0000FF00, 
+				   0x00FF0000, 
+				   0xFF000000
+#else
+				   0xFF000000,
+				   0x00FF0000, 
+				   0x0000FF00, 
+				   0x000000FF
+#endif
+				   );
+      if ( image == NULL ) {
+	return 0;
+      }
+      
+      /* Save the alpha blending attributes */
+      saved_flags = surface->flags&(SDL_SRCALPHA|SDL_RLEACCELOK);
+      saved_alpha = surface->format->alpha;
+      if ( (saved_flags & SDL_SRCALPHA) == SDL_SRCALPHA ) {
+	SDL_SetAlpha(surface, 0, 0);
+      }
+      
+      /* Copy the surface into the GL texture image */
+      area.x = 0;
+      area.y = 0;
+      area.w = surface->w;
+      area.h = surface->h;
+      SDL_BlitSurface(surface, &area, image, &area);
+      
+      /* Restore the alpha blending attributes */
+      if ( (saved_flags & SDL_SRCALPHA) == SDL_SRCALPHA ) {
+	SDL_SetAlpha(surface, saved_flags | SDL_OPENGL, saved_alpha);
+      }
+      
+      /* Create an OpenGL texture for the image */
+      glGenTextures(1, &texture);
+      glBindTexture(GL_TEXTURE_2D, texture);
+      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
+      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
+      /*      glTexImage2D(GL_TEXTURE_2D,
+		   0,
+		   GL_RGBA,
+		   w, h,
+		   0,
+		   GL_RGBA,
+		   GL_UNSIGNED_BYTE,
+		   image->pixels);
+      */
+      gluBuild2DMipmaps(GL_TEXTURE_2D,
+			3,
+			w,
+			h,
+			GL_RGBA,
+			GL_UNSIGNED_BYTE,
+			image->pixels);
+
+      SDL_FreeSurface(image); /* No longer needed */
+      
+      return texture;
     }
 }
@@ -104,38 +152,31 @@
       if (imageName)
 	{
-	  this->map=IMG_Load(imageName);
-	  if(!map)
+	  SDL_Surface* tmpSurf;
+	  if (this->texture)
+	    glDeleteTextures(1, &this->texture);
+	  // load the new Image to memory
+	  tmpSurf = IMG_Load(imageName);
+	  if(!tmpSurf)
 	    {
 	      PRINTF(1)("IMG_Load: %s\n", IMG_GetError());
 	      return false;
 	    }
-	  pImage->height = map->h;
-	  pImage->width  = map->w;
-	  pImage->data   = (GLubyte*)map->pixels;
-	  pImage->bpp    = map->format->BytesPerPixel;
-	  if (pImage->bpp == 3)
-	    pImage->format = GL_RGB;
-	  else if (pImage->bpp == 4)
-	    {
-	      pImage->format = GL_RGBA;
-	      SDL_SetAlpha(this->map, 0, 0);
-	    }
 
-	  if( !IMG_isPNG(SDL_RWFromFile(imageName, "rb")) && !IMG_isJPG(SDL_RWFromFile(imageName, "rb")))
-	    for (int i=0;i<map->h * map->w *3;i+=3)
-	      { 
-		GLuint temp = pImage->data[i];
-		pImage->data[i] = pImage->data[i+2];
-		pImage->data[i+2] = temp;
-	      }
-	  /* this is the real swapping algorithm */
-	  for( int i = 0 ; i < (pImage->height / 2) ; ++i )
-	    for( int j = 0 ; j < pImage->width * pImage->bpp; j += pImage->bpp )
-	      for(int k = 0; k < pImage->bpp; ++k)
-		swap( pImage->data[ (i * pImage->width * pImage->bpp) + j + k], pImage->data[ ( (pImage->height - i - 1) * pImage->width * pImage->bpp ) + j + k]);
+	  GLubyte* pixels = (GLubyte*)tmpSurf->pixels;
 	  
-	  this->loadTexToGL (this->pImage);
-	  SDL_FreeSurface(map);
-	  pImage->data = NULL;
+	  /* this swaps the Mapping so lowel left will be upper left */
+	  for( int i = 0 ; i < (tmpSurf->h / 2) ; ++i )
+	    for( int j = 0 ; j < tmpSurf->w * tmpSurf->format->BytesPerPixel; j += tmpSurf->format->BytesPerPixel )
+	      for(int k = 0; k < tmpSurf->format->BytesPerPixel; ++k)
+		swap( pixels[(i * tmpSurf->w * tmpSurf->format->BytesPerPixel) + j + k],
+		      pixels[ ( (tmpSurf->h - i - 1) * tmpSurf->w *  tmpSurf->format->BytesPerPixel) + j + k]);
+
+	  PRINTF(3)("loading Image %s\n", imageName);
+	  if (tmpSurf)
+	    this->texture = loadTexToGL(tmpSurf);
+
+	  
+	  SDL_FreeSurface(tmpSurf);
+	  return true;
 	}
       else
Index: orxonox/branches/physics/src/lib/graphics/importer/texture.h
===================================================================
--- orxonox/branches/physics/src/lib/graphics/importer/texture.h	(revision 3866)
+++ orxonox/branches/physics/src/lib/graphics/importer/texture.h	(revision 3953)
@@ -20,27 +20,14 @@
 {
  private:
-  //! Struct to handle Infos about an Image
-  struct Image
-  {
-    int rowSpan;    //!< The count of the rows this Image has.
-    GLuint width;   //!< The width of the Image.
-    GLuint height;  //!< The height of the Image.
-    GLuint bpp;     //!< BytesPerPixel
-    GLenum format;  //!< The Format of the PixelData
-    GLuint type;    //!< Type of the Image.
-    GLubyte *data;  //!< The Image Data comes here! DANGER: uncompressed data.
-  };
-  Image* pImage;    //!< The data of an Image
   GLuint texture;   //!< The Texture-ID of opengl from this Texture.
-  SDL_Surface* map; //!< The map SDL initializes for this element.
   char* searchTextureInPaths(const char* texName) const;
   void swap(unsigned char &a, unsigned char &b);
  public:
-  Texture(void);
-  Texture(const char* imageName);
+  Texture(const char* imageName = NULL);
   ~Texture(void);
+
   /** \returns The textureID of this texture.  */
   inline GLuint getTexture(void) {return this->texture;} 
-  bool loadTexToGL (Image* pImage);
+  GLuint loadTexToGL (SDL_Surface* surface);
 
   bool loadImage(const char* imageName);
Index: orxonox/branches/physics/src/lib/graphics/text_engine.cc
===================================================================
--- orxonox/branches/physics/src/lib/graphics/text_engine.cc	(revision 3866)
+++ orxonox/branches/physics/src/lib/graphics/text_engine.cc	(revision 3953)
@@ -36,5 +36,5 @@
 #include "vector.h"
 #include "debug.h"
-
+#include "list.h"
 
 ////////////
Index: orxonox/branches/physics/src/track_manager.cc
===================================================================
--- orxonox/branches/physics/src/track_manager.cc	(revision 3866)
+++ orxonox/branches/physics/src/track_manager.cc	(revision 3953)
@@ -111,6 +111,5 @@
     }
   // if not found
-  else 
-    return NULL;
+  return NULL;
 }
 
@@ -141,6 +140,5 @@
     }
   // if not found
-  else 
-    return NULL;
+  return NULL;
 }
 
@@ -762,4 +760,5 @@
 {
   TrackElement* tmpTrackElem;
+  TrackElement* tmpJoinElem;
   for (int i = 0; i < count; i++)
     if (!this->firstTrackElem->findByID(trackIDs[i]))
@@ -793,8 +792,10 @@
   for (int i = 0; i < count; i++)
     {
-      TrackElement* tmpJoinElem = this->firstTrackElem->findByID(trackIDs[i]);
-      if (tmpJoinElem->childCount == 0
-	  && tmpJoinElem->endTime > tmpLatestTime)
-	tmpLatestTime = tmpJoinElem->endTime;
+      if(tmpJoinElem = this->firstTrackElem->findByID(trackIDs[i]))
+	{
+	  if (tmpJoinElem->childCount == 0
+	      && tmpJoinElem->endTime > tmpLatestTime)
+	    tmpLatestTime = tmpJoinElem->endTime;
+	}
     }
   // time the main Join.
@@ -804,22 +805,24 @@
   for (int i = 1; i < count; i++)
     {
-      TrackElement* tmpJoinElem = this->firstTrackElem->findByID(trackIDs[i]);
-      if (tmpJoinElem->childCount > 0)
-	printf("!!This Curve has children, and as such will not be joined!!\n You can try joining other childless TrackElements to this one!");
-      else
-	{
-	  this->addPoint(tmpc2Point, tmpJoinElem);
-	  this->addPoint(tmpTangentPoint, tmpJoinElem);
-	  this->addPoint(tmpEndPoint, tmpJoinElem);
-	  // time all other Joins
-	  tmpJoinElem->jumpTime = tmpLatestTime - tmpJoinElem->endTime;
-	  
-	  //Copying Joint-Info
-	  tmpJoinElem->children = firstJoint->children;
-	  tmpJoinElem->childCount = firstJoint->childCount;
-	  tmpJoinElem->isSavePoint = firstJoint->isSavePoint;
-	  tmpJoinElem->isFork = firstJoint->isFork;
-
-	  tmpJoinElem->isJoined = true;
+      if( tmpJoinElem = this->firstTrackElem->findByID(trackIDs[i]))
+	{
+	  if (tmpJoinElem->childCount > 0)
+	    printf("!!This Curve has children, and as such will not be joined!!\n You can try joining other childless TrackElements to this one!");
+	  else
+	    {
+	      this->addPoint(tmpc2Point, tmpJoinElem);
+	      this->addPoint(tmpTangentPoint, tmpJoinElem);
+	      this->addPoint(tmpEndPoint, tmpJoinElem);
+	      // time all other Joins
+	      tmpJoinElem->jumpTime = tmpLatestTime - tmpJoinElem->endTime;
+	      
+	      //Copying Joint-Info
+	      tmpJoinElem->children = firstJoint->children;
+	      tmpJoinElem->childCount = firstJoint->childCount;
+	      tmpJoinElem->isSavePoint = firstJoint->isSavePoint;
+	      tmpJoinElem->isFork = firstJoint->isFork;
+	      
+	      tmpJoinElem->isJoined = true;
+	    }
 	}
     }
Index: orxonox/branches/physics/src/util/animation/animation.cc
===================================================================
--- orxonox/branches/physics/src/util/animation/animation.cc	(revision 3953)
+++ orxonox/branches/physics/src/util/animation/animation.cc	(revision 3953)
@@ -0,0 +1,130 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+   co-programmer: ...
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_ANIM
+
+#include "animation.h"
+#include "debug.h"
+#include "animation_player.h"
+
+/**
+   \brief creates a new Animation
+   
+   This also adds the Animation automatically to the AnimationPlayer's list
+*/
+Animation::Animation(void)
+{  
+  // initialize a beginning KeyFrame, that will be deleted afterwards
+  this->keyFrameCount = 0;
+  this->bHandled = true;
+  this->bDelete = false;
+  this->baseObject = NULL;
+
+  // setting default values
+  this->localTime = 0.0;
+  this->bRunning = true;
+
+  AnimationPlayer::getInstance()->addAnimation(this);
+}
+
+/**
+   \brief destructs the Animation
+   
+   this also takes the animation out of the AnimationPlayer's list (if it is there)
+*/
+Animation::~Animation(void)
+{
+  this->doNotHandle();
+}
+
+/**
+   \brief tells the AnimationPlayer, that we do not wish to  handle this animation
+   automatically.
+   
+   This means that it will not be ticked, and not be deleted with the AnimationPlayer
+*/
+void Animation::doNotHandle(void)
+{
+  if (this->bHandled)
+    AnimationPlayer::getInstance()->removeAnimation(this);
+}
+
+/**
+   \brief Sets the infinitymode
+   \param postInfinity How the Animation should advance after the last Keyframe
+*/
+void Animation::setInfinity(ANIM_INFINITY postInfinity)
+{
+  this->postInfinity = postInfinity;
+}
+
+/**
+   \brief handles the Animation if it gets out of boundraries eg. if animation is finished.
+*/
+void Animation::handleInfinity(void)
+{
+  switch (this->postInfinity)
+    {
+    case ANIM_INF_CONSTANT:
+      this->localTime = 0.0;
+      this->bRunning = false;
+      break;
+    case ANIM_INF_REPLAY:
+      this->replay();
+      break;
+    case ANIM_INF_REWIND:
+      this->stop();
+      break;
+    case ANIM_INF_DELETE: // this will possibly never be made
+      this->bDelete = true;
+      break;
+    }
+}
+
+/**
+   \brief plays the animation back from the current Time forward
+*/
+void Animation::play()
+{
+  this->bRunning = true;
+}
+
+/**
+   \brief Stops the animation. eg. pause(); rewind();
+*/
+void Animation::stop()
+{
+  this->rewind();
+  this->bRunning = true;
+  this->tick(0.0);
+  this->bRunning = false;
+}
+
+/**
+   \brief Pauses the animation. Stays at the current Time
+*/
+void Animation::pause()
+{
+  this->bRunning = false;
+}
+
+/**
+   \brief replays the animation, eg. rewind();play();
+*/
+void Animation::replay()
+{
+  this->rewind();
+  this->bRunning = true;
+}
Index: orxonox/branches/physics/src/util/animation/animation.h
===================================================================
--- orxonox/branches/physics/src/util/animation/animation.h	(revision 3953)
+++ orxonox/branches/physics/src/util/animation/animation.h	(revision 3953)
@@ -0,0 +1,123 @@
+/*! 
+    \file animation.h
+    A Subclass for all animations in orxonox
+*/
+
+#ifndef _ANIMATION_H
+#define _ANIMATION_H
+
+#include "list.h"
+#include "base_object.h"
+#include "confincl.h"  // must be here to determin the DEBUG-level
+
+// FORWARD DEFINITION
+
+//! An enumerator of Functions to describe the flow of the Animation
+/**
+   \todo check with Patrick it of
+
+   description in speed to the next keyframe:
+   ANIM_CONSTANT: 0, infinity.
+   ANIM_LINEAR: equal
+   ANIM_SINE: fast, slow, fast
+   ANIM_COSINE: slow, fast, slow
+   ANIM_EXP: slow, fast
+   ANIM_NEG_EXP: fast, slow
+   ANIM_RANDOM: eratic
+   
+   deprecated QUADRATIC
+*/
+typedef enum ANIM_FUNCTION {ANIM_CONSTANT,
+			    ANIM_LINEAR,
+			    ANIM_SINE,
+			    ANIM_COSINE,
+			    ANIM_EXP,
+			    ANIM_NEG_EXP,
+			    ANIM_QUADRATIC,
+			    ANIM_RANDOM};
+
+//! An enumerator describing what the animation should do after the last keyframe.
+/**
+   ANIM_INF_CONSTANT stays at the end of the animation
+   ANIM_INF_REPLAY loops back to the beginning and replays the animation
+   ANIM_INF_REWIND loops back to the beginning and then stops the animation
+   ANIM_INF_DELETE deletes the animation. !! THIS IS DANGEROUS !! only do this with non-class variables
+*/
+typedef enum ANIM_INFINITY {ANIM_INF_CONSTANT,
+			    ANIM_INF_REPLAY,
+			    ANIM_INF_REWIND,
+			    ANIM_INF_DELETE};//, ANIM_INF_LINEAR, ANIM_INF_PINGPONG;
+
+//! A Superclass for describing an animation (all animations will be derived from this one)
+/** implement in subclasses:
+ * 
+ * De-/Constructor
+ * Animation Functions
+ * virtual tick
+ * addKeyFrame
+ * List of keyFrames
+ * currentKeyFrame/nextKeyFrame
+ * virtual rewind, to go to the first Keyframe. (other functions will call this one)
+*/
+class Animation
+{
+ public:
+  virtual ~Animation(void);
+  void doNotHandle(void);
+
+  void setInfinity(ANIM_INFINITY postInfinity = ANIM_INF_CONSTANT);
+
+  void play(); // equals resume();
+  void stop();
+  void pause();
+  void replay();
+  //! A virtual function that should change to the first keyframe.
+  virtual void rewind() = 0;
+  /** \brief A virtual function that ticks the animation \param dt the time passed */
+  virtual void tick(float dt) = 0;
+
+  /**
+     \returns the BaseObject, this animation operates on
+  */
+  BaseObject* getBaseObject(void) const {return baseObject;}
+
+  /** \returns if the Animation should be deleted */
+  inline bool ifDelete(void) {return bDelete;}
+
+ protected:
+  Animation(void);
+
+  void handleInfinity(void);
+  // variables
+  float localTime;                //!< The Time passed since the beginning of the currentKeyFrame.
+  ANIM_INFINITY postInfinity;     //!< describing what the animation should do after the last keyframe.
+
+  BaseObject* baseObject;         //!< The same as object in the derived classes, but with reference to BaseObject
+  unsigned int keyFrameCount;     //!< The Count of KeyFrames.
+  bool bHandled;                  //!< If this Animation is handled by the AnimationPlayer.
+  bool bRunning;                  //!< If the animation is running
+  bool bDelete;                   //!< If true, the animation will be deleted through the AnimationPlayer.
+};
+
+
+/**********************TEST*******************************/
+class aTest
+{
+ public:
+  aTest() { last = 0.0;}
+  ~aTest() {}
+  void littleDebug(float f) {  diff = f - last; printf("f=%f, diff=%f\n", f,diff); last = f;}
+ private:
+  float diff;
+  float last;
+};
+
+//aTest::aTest() {}
+//aTest::~aTest() {}
+
+//void aTest::littleDebug(float f)
+
+/**********************TEST*******************************/
+
+
+#endif /* _ANIMATION_H */
